/* SPDX-License-Identifier: GPL-2.0 */
#ifndef ASM_SHARED_EXTRACT_H
#define ASM_SHARED_EXTRACT_H

#define MAP_WRITE	0x02 /* Writable memory */
#define MAP_EXEC	0x04 /* Executable memory */
#define MAP_ALLOC	0x10 /* Range needs to be allocated */
#define MAP_PROTECT	0x20 /* Set exact memory attributes for memory range */

struct efi_iofunc {
	void (*putstr)(const char *msg);
	void (*puthex)(unsigned long x);
	unsigned long (*map_range)(unsigned long start,
				   unsigned long end,
				   unsigned int flags);
};

void *efi_extract_kernel(struct boot_params *rmode,
			 struct efi_iofunc *iofunc,
			 unsigned char *input_data,
			 unsigned long input_len,
			 unsigned char *output,
			 unsigned long output_len);

#endif /* ASM_SHARED_EXTRACT_H */
