/* SPDX-License-Identifier: GPL-2.0 */
#ifndef ASM_SHARED_PAGETABLE_H
#define ASM_SHARED_PAGETABLE_H

#define MAP_WRITE	0x02 /* Writable memory */
#define MAP_EXEC	0x04 /* Executable memory */
#define MAP_ALLOC	0x10 /* Range needs to be allocated */
#define MAP_PROTECT	0x20 /* Set exact memory attributes for memory range */
#define MAP_NOFLUSH	0x40 /* Avoid flushing TLB */

#define TRAMPOLINE_32BIT_SIZE		(3 * PAGE_SIZE)

#define TRAMPOLINE_32BIT_PLACEMENT_MAX	(0xA0000)

#define TRAMPOLINE_32BIT_PGTABLE_OFFSET	0

#define TRAMPOLINE_32BIT_CODE_OFFSET	PAGE_SIZE
#define TRAMPOLINE_32BIT_CODE_SIZE	0x80

#define TRAMPOLINE_32BIT_STACK_END	TRAMPOLINE_32BIT_SIZE

#ifndef __ASSEMBLER__

extern unsigned long *trampoline_32bit;

extern void trampoline_32bit_src(void *return_ptr);

#endif /* __ASSEMBLER__ */
#endif /* ASM_SHARED_PAGETABLE_H */
